%{
/*

Copyright (c) 2009, Barry Watson
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY Barry Watson ''AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Barry Watson BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include "y.tab.h"
#include <string.h>

int linecount=1;
extern char *infilename;
extern void output_line (void);
void newline(void);

%}
%%

[ \t]     ; /*ignore whitespace*/
periodic	{return PERIODIC;}
sporadic        {return SPORADIC;}
deadline	{return DEADLINE;}
period    {return PERIOD;}
resource  {return RESOURCE;}
count     {return COUNT;}
uses      {return USES;}
of        {return OF;}
entrypoint {return ENTRYPOINT;}
available {return AVAILABLE;}
option    {return OPTION;}
macro     {return MACRO;}
cab       {return CAB;}
[a-zA-Z_][a-zA-Z_0-9]* {yylval.str = strdup(yytext); return ID;}
[0-9]+    {yylval.num = atoi(yytext); return NUM;}
\n        {newline();}
#.*       ;
.         {return yytext[0];}


%% 

yywrap() {return 1;}


int yyerror(char *s)
{
	fprintf(stderr, "%d: %s at %s\n", linecount, s, yytext);
	exit(1);
}

void newline (void)
{
	linecount++;
}
